/*
    Text maid
    copyright (c) 1998-2002 Iwamoto,Kazuki http://www.maid.org/ iwm@maid.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <gdk/gdkkeysyms.h>
#include "ftype.h"
#include "prop.h"


/******************************************************************************
*                                                                             *
* ץѥƥؿ                                                            *
*                                                                             *
******************************************************************************/
static gboolean property_clicked_ok,color_list[12];
static gchar *fontname;
static gint ft_id;
static GdkColor gdk_color[12];
static GtkWidget *dialog;
static GtkWidget *button0,*button3;
static GtkWidget *check0,*check1,*check2,*check3,*check4,*check5;
static GtkWidget *check6,*check7,*check8,*check9,*check10,*check11;
static GtkWidget *clist,*entry0,*entry1,*label,*spin0,*spin1;
static gchar *color_name[12]={N_("ʸ"),N_("ط"),N_("ȥ륳"),
					N_("ѥڡ"),N_("ԥ"),N_("ֲ"),
					N_("ޡ"),N_("å"),N_("򤵤줿ʸ"),
					N_("򤵤줿ط"),N_("ʸ()"),N_("ط()")};


/* OKܥɽ/ɽȽ */
static void property_dialog_ok_sensitive(GtkWidget *widget,gpointer user_data)
{
	gtk_widget_set_sensitive(button3,
		(entry0==NULL || strlen(gtk_entry_get_text(GTK_ENTRY(entry0)))>0)
		&& (entry1==NULL || strlen(gtk_entry_get_text(GTK_ENTRY(entry1)))>0));
}


/* ƥ࿧ */
static void property_dialog_toggled(GtkWidget *widget,gpointer user_data)
{
	gtk_clist_unselect_all(GTK_CLIST(clist));
	gtk_widget_set_sensitive(clist,
					!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check10)));
	gtk_widget_set_sensitive(button0,FALSE);
	property_dialog_ok_sensitive(widget,user_data);
}


/* ꥹȥܥå */
static void property_dialog_select_row(GtkWidget *widget,
				gint row,gint column,GdkEventButton *event,gpointer user_data)
{
	color_list[row]=TRUE;
	gtk_widget_set_sensitive(button0,TRUE);
}


/* ꥹȥܥå */
static void property_dialog_unselect_row(GtkWidget *widget,
				gint row,gint column,GdkEventButton *event,gpointer user_data)
{
	gint i;

	color_list[row]=FALSE;
	for (i=0;i<12;i++)
		if (color_list[i])
			break;
	gtk_widget_set_sensitive(button0,i<12);
}


/* OK줿Ȥ */
static void property_dialog_clicked_color_ok(GtkWidget *widget,
													GtkWidget *dialog_color)
{
	gchar *xpm[18];
	gint i;
	gdouble color[4];
	GdkPixmap *pixmap;
	GdkBitmap *mask;

	gtk_color_selection_get_color(GTK_COLOR_SELECTION(
					GTK_COLOR_SELECTION_DIALOG(dialog_color)->colorsel),color);
	xpm[0]="24 16 1 1";
	for (i=2;i<18;i++)
		xpm[i]="XXXXXXXXXXXXXXXXXXXXXXXX";
	for (i=0;i<12;i++) {
		if (color_list[i]) {
			gdk_color[i].red=color[0]*0xffff;
			gdk_color[i].green=color[1]*0xffff;
			gdk_color[i].blue=color[2]*0xffff;
		}
		xpm[1]=g_strdup_printf("X\tc #%02X%02X%02X",
			gdk_color[i].red/256,gdk_color[i].green/256,gdk_color[i].blue/256);
		pixmap=gdk_pixmap_create_from_xpm_d(dialog->window,&mask,NULL,xpm);
		g_free(xpm[1]);
		gtk_clist_set_pixtext(GTK_CLIST(clist),i,0,
												color_name[i],8,pixmap,mask);
	}
	property_dialog_ok_sensitive(NULL,NULL);
    gtk_widget_destroy(dialog_color);
}


/* ܥ󤬲줿 */
static void property_dialog_clicked_color(GtkWidget *widget,gpointer user_data)
{
	gint i;
	gdouble color[4];
	GtkWidget *dialog_color;

	dialog_color=gtk_color_selection_dialog_new(_(""));
	gtk_signal_connect(GTK_OBJECT(dialog_color),"destroy",gtk_main_quit,NULL);
	gtk_signal_connect(GTK_OBJECT(
					GTK_COLOR_SELECTION_DIALOG(dialog_color)->ok_button),
					"clicked",property_dialog_clicked_color_ok,dialog_color);
	gtk_signal_connect_object(
		GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(dialog_color)->cancel_button),
						"clicked",gtk_widget_destroy,GTK_OBJECT(dialog_color));
	for (i=0;i<12;i++)
		if (color_list[i]) {
			color[0]=(gdouble)gdk_color[i].red/0xffff;
			color[1]=(gdouble)gdk_color[i].green/0xffff;
			color[2]=(gdouble)gdk_color[i].blue/0xffff;
			color[3]=0;
			gtk_color_selection_set_color(GTK_COLOR_SELECTION(
					GTK_COLOR_SELECTION_DIALOG(dialog_color)->colorsel),color);
			break;
		}

	gtk_widget_show(dialog_color);
	gtk_grab_add(dialog_color);
	gtk_main();
}


/* եȤOK줿Ȥ */
static void property_dialog_clicked_font_ok(GtkWidget *widget,
														GtkWidget *dialog_font)
{
	gchar *name;

	name=gtk_font_selection_dialog_get_font_name(
									GTK_FONT_SELECTION_DIALOG(dialog_font));
	if (name!=NULL && name[0]!='\0') {
		g_free(fontname);
		fontname=name;
		property_dialog_ok_sensitive(NULL,NULL);
	}
    gtk_widget_destroy(dialog_font);
}


/* եȥܥ󤬲줿 */
static void property_dialog_clicked_font(GtkWidget *widget,gpointer user_data)
{
	GtkWidget *dialog_font;

	dialog_font=gtk_font_selection_dialog_new(_("ե"));
	gtk_signal_connect(GTK_OBJECT(dialog_font),"destroy",gtk_main_quit,NULL);
	gtk_signal_connect(GTK_OBJECT(
						GTK_FONT_SELECTION_DIALOG(dialog_font)->ok_button),
						"clicked",property_dialog_clicked_font_ok,dialog_font);
	gtk_signal_connect_object(
			GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(dialog_font)->cancel_button),
						"clicked",gtk_widget_destroy,GTK_OBJECT(dialog_font));
	if (fontname!=NULL)
		gtk_font_selection_dialog_set_font_name(
							GTK_FONT_SELECTION_DIALOG(dialog_font),fontname);
	gtk_widget_show(dialog_font);
	gtk_grab_add(dialog_font);
	gtk_main();
}


/* ե륿ץܥ󤬲줿 */
static void property_dialog_clicked_ftype(GtkWidget *widget,gpointer user_data)
{
	gint pos;

	if (ftype_dialog(&pos)) {
		if (pos>=0) {
			ft_id=ftype[pos].ft_id;
			gtk_label_set_text(GTK_LABEL(label),ftype[pos].text);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check0),
														ftype[pos].gline);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check1),
														ftype[pos].space);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check2),
														ftype[pos].crlf);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check3),
														ftype[pos].mline);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check4),
														ftype[pos].limit);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check5),
														ftype[pos].code);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check6),
														ftype[pos].uline);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check7),
														ftype[pos].vline);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check8),
														ftype[pos].eof);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check9),
														ftype[pos].overwrite);
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check10),
														ftype[pos].syscol);
			gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin0),
														ftype[pos].margin);
			gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin1),ftype[pos].tab);
			memcpy(gdk_color,ftype[pos].color,sizeof(GdkColor)*12);
			g_free(fontname);
			fontname=g_strdup(ftype[pos].fontname);
			gtk_widget_set_sensitive(button3,TRUE);
		} else {
			ft_id=-1;
			gtk_label_set_text(GTK_LABEL(label),_("ե륿פʤ"));
			property_dialog_ok_sensitive(NULL,NULL);
		}
	}
}


/* OKܥ󤬲줿 */
static void property_dialog_clicked_ok(GtkWidget *widget,FTYPE *ft)
{
	ft->ft_id=ft_id;
	if (entry0!=NULL) {
		g_free(ft->text);
		ft->text=g_strdup(gtk_entry_get_text(GTK_ENTRY(entry0)));
	}
	if (entry1!=NULL) {
		g_free(ft->ext);
		ft->ext=g_strdup(gtk_entry_get_text(GTK_ENTRY(entry1)));
	}
	ft->margin=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin0));
	ft->tab=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin1));
	ft->gline=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check0));
	ft->space=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check1));
	ft->crlf=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check2));
	ft->mline=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check3));
	ft->limit=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check4));
	ft->code=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check5));
	ft->uline=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check6));
	ft->vline=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check7));
	ft->eof=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check8));
	ft->overwrite=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check9));
	ft->syscol=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check10));
	if (check11!=NULL)
		ft->associate=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check11));
	memcpy(ft->color,gdk_color,sizeof(GdkColor)*12);
	g_free(ft->fontname);
	ft->fontname=fontname;
	fontname=NULL;
    gtk_widget_destroy(dialog);
	property_clicked_ok=TRUE;
}


/* ԥܥǥ꥿󤬲줿 */
static void property_dialog_activate(GtkWidget *widget,FTYPE *ft)
{
	if ((entry0==NULL || strlen(gtk_entry_get_text(GTK_ENTRY(entry0)))>0)
		&& (entry1==NULL || strlen(gtk_entry_get_text(GTK_ENTRY(entry1)))>0))
		property_dialog_clicked_ok(widget,ft);
}


/* ESC줿 */
static gboolean property_dialog_key_press(GtkWidget *widget,GdkEventKey *event,
															gpointer user_data)
{
	if (event->keyval==GDK_Escape)
		gtk_widget_destroy(widget);
	return FALSE;
}


gboolean property_dialog(FTYPE *ft)
{
	gchar *xpm[18];
	gint i;
	guint key;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkAccelGroup *accel;
	GtkWidget *button1,*button2,*button4,*scroll;
	GtkWidget *hbox,*tbox,*vbox;
	GtkWidget *frame0,*frame1,*frame2,*frame3,*frame4;

	/* ᥤ󥦥ɥ */
	dialog=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(dialog),ft->text==NULL || ft->ext==NULL
								?_("ץѥƥ"):_("ե륿פξܺ"));
	gtk_signal_connect_after(GTK_OBJECT(dialog),"key-press-event",
							GTK_SIGNAL_FUNC(property_dialog_key_press),NULL);
	gtk_signal_connect(GTK_OBJECT(dialog),"destroy",gtk_main_quit,NULL);
	/* 졼 */
	accel=gtk_accel_group_new();
	gtk_accel_group_attach(accel,GTK_OBJECT(dialog));
	/* ܥ */
	button0=gtk_button_new_with_label(NULL);
	button1=gtk_button_new_with_label(NULL);
	button2=ft->text==NULL && ft->ext==NULL
										?gtk_button_new_with_label(NULL):NULL;
	button3=gtk_button_new_with_label(_("λ"));
	button4=gtk_button_new_with_label(_(""));
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(button0)->child),
																_("ѹ(_P)"));
	gtk_widget_add_accelerator(button0,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(button1)->child),
															_("ե(_F)"));
	gtk_widget_add_accelerator(button1,"clicked",accel,key,GDK_MOD1_MASK,0);
	if (button2!=NULL) {
		key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(button2)->child),
													_("ե륿(_A)"));
		gtk_widget_add_accelerator(button2,"clicked",accel,key,
															GDK_MOD1_MASK,0);
	}
	gtk_signal_connect(GTK_OBJECT(button0),"clicked",
										property_dialog_clicked_color,NULL);
	gtk_signal_connect(GTK_OBJECT(button1),"clicked",
										property_dialog_clicked_font,NULL);
	if (button2!=NULL)
		gtk_signal_connect(GTK_OBJECT(button2),"clicked",
										property_dialog_clicked_ftype,NULL);
	gtk_signal_connect(GTK_OBJECT(button3),"clicked",
										property_dialog_clicked_ok,ft);
	gtk_signal_connect_object(GTK_OBJECT(button4),"clicked",
										gtk_widget_destroy,GTK_OBJECT(dialog));
	GTK_WIDGET_SET_FLAGS(button0,GTK_CAN_DEFAULT);
	GTK_WIDGET_SET_FLAGS(button1,GTK_CAN_DEFAULT);
	if (button2!=NULL)
		GTK_WIDGET_SET_FLAGS(button2,GTK_CAN_DEFAULT);
	GTK_WIDGET_SET_FLAGS(button3,GTK_CAN_DEFAULT);
	GTK_WIDGET_SET_FLAGS(button4,GTK_CAN_DEFAULT);
	/* åܥ */
	check0=gtk_check_button_new_with_label(NULL);
	check1=gtk_check_button_new_with_label(NULL);
	check2=gtk_check_button_new_with_label(NULL);
	check3=gtk_check_button_new_with_label(NULL);
	check4=gtk_check_button_new_with_label(NULL);
	check5=gtk_check_button_new_with_label(NULL);
	check6=gtk_check_button_new_with_label(NULL);
	check7=gtk_check_button_new_with_label(NULL);
	check8=gtk_check_button_new_with_label(NULL);
	check9=gtk_check_button_new_with_label(NULL);
	check10=gtk_check_button_new_with_label(NULL);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check0)->child),
															_("å(_G)"));
	gtk_widget_add_accelerator(check0,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check1)->child),
														_("ѥڡ(_S)"));
	gtk_widget_add_accelerator(check1,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check2)->child),
														_("ԥ(_E)"));
	gtk_widget_add_accelerator(check2,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check3)->child),
													_("ޡɽ(_M)"));
	gtk_widget_add_accelerator(check3,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check4)->child),
															_("ޤ֤(_I)"));
	gtk_widget_add_accelerator(check4,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check5)->child),
														_("ʸ(_C)"));
	gtk_widget_add_accelerator(check5,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check6)->child),_("(_U)"));
	gtk_widget_add_accelerator(check6,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check7)->child),_("(_V)"));
	gtk_widget_add_accelerator(check7,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check8)->child),
									_("եκǸ^Z(1A)դ(_Z)"));
	gtk_widget_add_accelerator(check8,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check9)->child),
												_("¸ǧ(_O)"));
	gtk_widget_add_accelerator(check9,"clicked",accel,key,GDK_MOD1_MASK,0);
	key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check10)->child),
													_("ƥ࿧Ȥ(_Y)"));
	gtk_widget_add_accelerator(check10,"clicked",accel,key,GDK_MOD1_MASK,0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check0),ft->gline);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check1),ft->space);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check2),ft->crlf);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check3),ft->mline);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check4),ft->limit);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check5),ft->code);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check6),ft->uline);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check7),ft->vline);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check8),ft->eof);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check9),ft->overwrite);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check10),ft->syscol);
	gtk_signal_connect(GTK_OBJECT(check0),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check1),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check2),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check3),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check4),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check5),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check6),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check7),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check8),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check9),"toggled",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(check10),"toggled",
											property_dialog_toggled,NULL);
	if (ft->text!=NULL && ft->ext!=NULL) {
		check11=gtk_check_button_new_with_label(NULL);
		key=gtk_label_parse_uline(GTK_LABEL(GTK_BIN(check11)->child),
										_("ե륿פϢŤ(_A)"));
		gtk_widget_add_accelerator(check11,"clicked",accel,key,GDK_MOD1_MASK,0);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check11),ft->associate);
		gtk_signal_connect(GTK_OBJECT(check11),"toggled",
											property_dialog_ok_sensitive,NULL);
	} else {
		check11=NULL;
	}
	/* ȥ꡼/٥ */
	label=NULL;
	if (ft->text!=NULL && ft->ext!=NULL) {
		entry0=gtk_entry_new_with_max_length(256);
		entry1=gtk_entry_new_with_max_length(256);
		gtk_entry_set_text(GTK_ENTRY(entry0),ft->text);
		gtk_entry_set_text(GTK_ENTRY(entry1),ft->ext);
		gtk_signal_connect(GTK_OBJECT(entry0),"changed",
											property_dialog_ok_sensitive,NULL);
		gtk_signal_connect(GTK_OBJECT(entry1),"changed",
											property_dialog_ok_sensitive,NULL);
		gtk_signal_connect(GTK_OBJECT(entry0),"activate",
												property_dialog_clicked_ok,ft);
		gtk_signal_connect(GTK_OBJECT(entry1),"activate",
												property_dialog_clicked_ok,ft);
	} else {
		if (ft->ft_id>=0) {
			/* ե륿פ */
			for (i=0;i<ftnum;i++)
				if (ft->ft_id==ftype[i].ft_id) {
					label=gtk_label_new(ftype[i].text);
					break;
				}
			if (label==NULL)
				label=gtk_label_new(_("ե륿"));
		} else {
			/* ե륿פʤ */
			label=gtk_label_new(_("ե륿פʤ"));
		}
		gtk_misc_set_alignment(GTK_MISC(label),0,0.5);
		entry0=entry1=NULL;
	}
	/* ꥹȥܥå */
	clist=gtk_clist_new(1);
	gtk_clist_column_titles_passive(GTK_CLIST(clist));
	gtk_clist_set_selection_mode(GTK_CLIST(clist),GTK_SELECTION_MULTIPLE);
	xpm[0]="24 16 1 1";
	for (i=2;i<18;i++)
		xpm[i]="XXXXXXXXXXXXXXXXXXXXXXXX";
	for (i=0;i<12;i++) {
		xpm[1]=g_strdup_printf("X\tc #%02X%02X%02X",
			ft->color[i].red/256,ft->color[i].green/256,ft->color[i].blue/256);
		pixmap=gdk_pixmap_create_from_xpm_d(window->window,&mask,NULL,xpm);
		g_free(xpm[1]);
		gtk_clist_append(GTK_CLIST(clist),&color_name[i]);
		gtk_clist_set_pixtext(GTK_CLIST(clist),i,0,
												color_name[i],8,pixmap,mask);
		color_list[i]=FALSE;
	}
	gtk_clist_set_column_width(GTK_CLIST(clist),0,
						gtk_clist_optimal_column_width(GTK_CLIST(clist),0));
	gtk_signal_connect(GTK_OBJECT(clist),"select-row",
											property_dialog_select_row,NULL);
	gtk_signal_connect(GTK_OBJECT(clist),"unselect-row",
											property_dialog_unselect_row,NULL);
	/* 륦ɥ */
	scroll=gtk_scrolled_window_new(NULL,NULL);
	gtk_container_add(GTK_CONTAINER(scroll),clist);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
										GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
	/* ԥܥ */
	spin0=gtk_spin_button_new(
		GTK_ADJUSTMENT(gtk_adjustment_new(ft->margin,1,G_MAXINT,1,5,0)),0,0);
	spin1=gtk_spin_button_new(
		GTK_ADJUSTMENT(gtk_adjustment_new(ft->tab,1,G_MAXINT,1,5,0)),0,0);
	gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(spin0),TRUE);
	gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(spin1),TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(spin0),GTK_SHADOW_IN);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(spin1),GTK_SHADOW_IN);
	gtk_signal_connect(GTK_OBJECT(spin0),"activate",
												property_dialog_activate,ft);
	gtk_signal_connect(GTK_OBJECT(spin1),"activate",
												property_dialog_activate,ft);
	gtk_signal_connect(GTK_OBJECT(spin0),"changed",
											property_dialog_ok_sensitive,NULL);
	gtk_signal_connect(GTK_OBJECT(spin1),"changed",
											property_dialog_ok_sensitive,NULL);
	/* ե졼ȥܥå */
	tbox=gtk_hbox_new(FALSE,8);
	if (entry0!=NULL && entry1!=NULL) {
		hbox=gtk_hbox_new(FALSE,0);
		gtk_box_pack_start(GTK_BOX(hbox),
									gtk_label_new(_("ʸ")),FALSE,FALSE,0);
		gtk_box_pack_start(GTK_BOX(hbox),entry0,TRUE,TRUE,0);
		gtk_box_pack_start(GTK_BOX(tbox),hbox,TRUE,TRUE,0);
		hbox=gtk_hbox_new(FALSE,0);
		gtk_box_pack_start(GTK_BOX(hbox),
									gtk_label_new(_("ĥ")),FALSE,FALSE,0);
		gtk_box_pack_start(GTK_BOX(hbox),entry1,TRUE,TRUE,0);
		gtk_box_pack_start(GTK_BOX(tbox),hbox,TRUE,TRUE,0);
	} else {
		gtk_box_pack_start(GTK_BOX(tbox),label,TRUE,TRUE,0);
	}

	frame0=gtk_frame_new(_("ɽ"));
	hbox=gtk_hbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(hbox),8);
	gtk_box_pack_start(GTK_BOX(hbox),check0,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check1,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check2,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame0),hbox);

	frame1=gtk_frame_new(_("ޡ"));
	hbox=gtk_hbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(hbox),8);
	gtk_box_pack_start(GTK_BOX(hbox),spin0,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check3,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check4,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame1),hbox);

	frame2=gtk_frame_new(_(""));
	hbox=gtk_hbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(hbox),8);
	gtk_box_pack_start(GTK_BOX(hbox),spin1,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check5,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check6,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),check7,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame2),hbox);

	frame3=gtk_frame_new(_("¸"));
	vbox=gtk_vbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(vbox),8);
	gtk_box_pack_start(GTK_BOX(vbox),check8,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),check9,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame3),vbox);

	frame4=gtk_frame_new(_(""));
	vbox=gtk_vbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(vbox),8);
	gtk_box_pack_start(GTK_BOX(vbox),scroll,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox),check10,FALSE,FALSE,0);
	hbox=gtk_hbox_new(FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox),button0,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(frame4),vbox);

	vbox=gtk_vbox_new(FALSE,8);
	gtk_box_pack_start(GTK_BOX(vbox),frame0,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),frame1,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),frame2,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),frame3,FALSE,FALSE,0);

	hbox=gtk_hbox_new(FALSE,8);
	gtk_box_pack_start(GTK_BOX(hbox),vbox,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(hbox),frame4,FALSE,FALSE,0);

	vbox=gtk_vbox_new(FALSE,8);
	gtk_container_set_border_width(GTK_CONTAINER(vbox),8);
	gtk_box_pack_start(GTK_BOX(vbox),tbox,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
	hbox=gtk_hbox_new(FALSE,8);
	gtk_box_pack_start(GTK_BOX(hbox),button1,FALSE,FALSE,0);
	if (button2!=NULL)
		gtk_box_pack_start(GTK_BOX(hbox),button2,FALSE,FALSE,0);
	if (check11!=NULL)
		gtk_box_pack_start(GTK_BOX(hbox),check11,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox),button4,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(hbox),button3,FALSE,FALSE,0);
	gtk_box_pack_end(GTK_BOX(vbox),hbox,FALSE,FALSE,0);

	gtk_container_add(GTK_CONTAINER(dialog),vbox);

	/* ɽ */
	gtk_widget_set_sensitive(button0,FALSE);
	gtk_widget_set_sensitive(button3,FALSE);
	gtk_widget_set_sensitive(clist,!ft->syscol);
	gtk_widget_grab_focus(button4);

	ft_id=ft->ft_id;
	memcpy(gdk_color,ft->color,sizeof(GdkColor)*12);
	fontname=g_strdup(ft->fontname);
	property_clicked_ok=FALSE;

	gtk_window_set_policy(GTK_WINDOW(dialog),FALSE,TRUE,FALSE);
	gtk_grab_add(dialog);
	gtk_widget_show_all(dialog);
	gtk_main();

	g_free(fontname);

	return property_clicked_ok;
}
